#!/usr/bin/env perl

use Rappture;

$exampleDir = $ENV{'TOOLDIR'} . "/examples";

# open the XML file containing the run parameters

$driver = Rappture::RpLibrary->new($ARGV[0]);

$Plume_Height = $driver->get("input.(Plume_Height).current");
$Eruption_Mass = $driver->get("input.(Eruption_Mass).current");
$Max_Grainsize = $driver->get("input.(Max_Grainsize).current");
$Min_Grainsize = $driver->get("input.(Min_Grainsize).current");
$Median_Grainsize = $driver->get("input.(Median_Grainsize).current");
$STD_Grainsize = $driver->get("input.(STD_Grainsize).current");
$Vent_Easting = $driver->get("input.(Vent_Easting).current");
$Vent_Northing = $driver->get("input.(Vent_Northing).current");
$Vent_Elevation = $driver->get("input.(Vent_Elevation).current");
$Eddy_Const = $driver->get("input.(Eddy_Constant).current");
$Diffusion_Coefficient = $driver->get("input.(Diffusion_Coefficient).current");
$Fall_Time_Threshold = $driver->get("input.(Fall_Time_Threshold).current");
$Lithic_Density = $driver->get("input.(Lithic_Density).current");
$Pumice_Density = $driver->get("input.(Pumice_Density).current");
$Col_Steps = $driver->get("input.(Column_Steps).current");
$Plume_Model = $driver->get("input.(Plume_Model).current");
$Plume_Ratio = $driver->get("input.(Plume_Ratio).current");
$Save_File = $driver->get("input.(Save_File).current");
$Filename = $driver->get("input.(Filename).current");

$wind = $driver->get("input.(wind).current");
$grid = $driver->get("input.(grid).current");
$config = $driver->get("input.(config).current");
$configexist = length ($config);

# If the user selected the example files, load the data

# Cerro Negro

if ($wind eq "constant") {
    $wind = "";
    open(IN, "$exampleDir/w_constant.wind");
    while (<IN>) { $wind .= $_; }
    close(IN);
}

if ($grid eq "Cerro_Negro") {
    $grid = "";
    open(IN, "$exampleDir/Cerro_Negro_1992.grid");
    while (<IN>) { $grid .= $_; }
    close(IN);
}


# Irazu

if ($wind eq "stratified") {
    $wind = "";
    open(IN, "$exampleDir/w_stratified.wind");
    while (<IN>) { $wind .= $_; }
    close(IN);
}

if ($grid eq "Irazu") {
    $grid = "";
    open(IN, "$exampleDir/Irazu_1968.grid");
    while (<IN>) { $grid .= $_; }
    close(IN);
}


# Pululagua

if ($wind eq "none") {
    $wind = "";
    open(IN, "$exampleDir/w_no.wind");
    while (<IN>) { $wind .= $_; }
    close(IN);
}

if ($grid eq "Pululagua") {
    $grid = "";
    open(IN, "$exampleDir/Pululagua_2350BP.grid");
    while (<IN>) { $grid .= $_; }
    close(IN);
}



# Save the data to the respective files so tephra can access them

open(WIND, ">wind.txt");
print WIND "$wind\n";
close(WIND);

open(GRID, ">grid.txt");
print GRID "$grid\n";
close(GRID);

$configtoprint="PLUME_HEIGHT $Plume_Height\n
ERUPTION_MASS $Eruption_Mass\n
MAX_GRAINSIZE $Max_Grainsize\n
MIN_GRAINSIZE $Min_Grainsize\n
MEDIAN_GRAINSIZE $Median_Grainsize\n
STD_GRAINSIZE $STD_Grainsize\n
VENT_EASTING $Vent_Easting\n
VENT_NORTHING $Vent_Northing\n
VENT_ELEVATION $Vent_Elevation\n
EDDY_CONST $Eddy_Const\n
DIFFUSION_COEFFICIENT $Diffusion_Coefficient\n
FALL_TIME_THRESHOLD $Fall_Time_Threshold\n
LITHIC_DENSITY $Lithic_Density\n
PUMICE_DENSITY $Pumice_Density\n
COL_STEPS $Col_Steps\n
PLUME_MODEL $Plume_Model\n
PLUME_RATIO $Plume_Ratio";

if ($configexist > 100){
open CONFIG, ">T2parameters.txt";
print CONFIG "$config\n";
close(CONFIG);}
else {
open FILE1, ">T2parameters.txt";
print FILE1 "$configtoprint";
close(FILE1);}

#open CONFIGMAKE, "T2parameters.txt";
#while (<CONFIGMAKE>){
#if ($.==1) {chop(@Plume_Height =split(/ /,$_));}
#if ($.==3) {chop(@Eruption_Mass =split(/ /,$_));}
#if ($.==5) {chop(@Max_Grainsize =split(/ /,$_));}
#if ($.==7) {chop(@Min_Grainsize =split(/ /,$_));}
#if ($.==9) {chop(@Med_Grainsize =split(/ /,$_));}
#if ($.==11) {chop(@STD_Grainsize =split(/ /,$_));}
#if ($.==13) {chop(@V_East =split(/ /,$_));}
#if ($.==15) {chop(@V_North =split(/ /,$_));}
#if ($.==17) {chop(@V_Ele =split(/ /,$_));}
#if ($.==19) {chop(@Eddy_Const =split(/ /,$_));}
#if ($.==21) {chop(@Dif_Coef =split(/ /,$_));}
#if ($.==23) {chop(@F_T_Thresh =split(/ /,$_));}
#if ($.==25) {chop(@L_Density =split(/ /,$_));}
#if ($.==27) {chop(@P_Density =split(/ /,$_));}
#if ($.==29) {chop(@Col_Steps =split(/ /,$_));}
#if ($.==31) {chop(@Plume_Model =split(/ /,$_));}
#if ($.==33) {chop(@Plume_Ratio =split(/ /,$_));}}
#close CONFIGMAKE;

#open NEW, ">examples/last_run.xml";
#open OLD,"examples/lasttest.xml";
#while (<OLD>) {
#	if ($.==13) {print NEW "            <current>$Plume_Height[1]</current>\n" ;}
#	if ($.==20) {print NEW "            <current>$Eruption_Mass[1]</current>\n" ;}
#	if ($.==27) {print NEW "            <current>$Max_Grainsize[1]</current>\n" ;}
#	if ($.==34) {print NEW "            <current>$Min_Grainsize[1]</current>\n" ;}
#	if ($.==41) {print NEW "            <current>$Med_Grainsize[1]</current>\n" ;}
#	if ($.==48) {print NEW "            <current>$STD_Grainsize[1]</current>\n" ;}
#	if ($.==55) {print NEW "            <current>$V_East[1]</current>\n" ;}
#	if ($.==62) {print NEW "            <current>$V_North[1]</current>\n" ;}
#	if ($.==69) {print NEW "            <current>$V_Ele[1]</current>\n" ;}
#	if ($.==76) {print NEW "            <current>$Eddy_Const[1]</current>\n" ;}
#	if ($.==83) {print NEW "            <current>$Dif_Coef[1]</current>\n" ;}
#	if ($.==90) {print NEW "            <current>$F_T_Thresh[1]</current>\n" ;}
#	if ($.==97) {print NEW "            <current>$L_Density[1]</current>\n" ;}
#	if ($.==104) {print NEW "            <current>$L_Density[1]</current>\n" ;}
#	if ($.==111) {print NEW "            <current>$Col_Steps[1]</current>\n" ;}
#	if ($.==118) {print NEW "            <current>$Plume_Model[1]</current>\n" ;}
#	if ($.==125) {print NEW "            <current>$Plume_Ratio[1]</current>\n" ;}
#	elsif (($. != 13) && ($. !=20) && ($. !=27) && ($. !=34) && ($. !=41) && ($. !=48) && ($. !=55) && ($. !=62) && ($. !=69) && ($. !=76) && ($. !=83) && ($. !=90) && ($. !=97) && ($. !=104) && ($. !=111) && ($. !=118) && ($. !=125)) {print NEW $_;}
#    }

#    close(OLD);
#    close(NEW);


$driver->put("output.string(outa).about.label", "TEPHRA2 Output", 0);
open(TEPHRA, 'tephra2 T2parameters.txt grid.txt wind.txt 2>&1|');
while (<TEPHRA>) {
    $driver->put("output.string(outa).current", $_, 1);
}
close(TEPHRA);

$driver->put("output.string(outb).about.label","TEPHRA2 Configuration File",0);
$driver->put("output.string(outb).current",$configtoprint,0);

$driver->result();
exit;
